%PID controller example
%Z-N tuning rule
%Z-N and C-C tuning rules
%PID control of motor position
num=0.5;
den=conv([1 0],[1 2]);
b1=0;
b0=0.5;
a1=2;    %[1 0.5 0.04]
a0=0;
%closed-loop performance specification
xi=0.707;
wn=3;
lambda1=3;
Acl_2=[1 2*xi*wn wn^2];  %s2+2xiwns+wn^2
Acl=conv(Acl_2,[1 2*lambda1 lambda1^2]); % put together closed-loop poles. 4th order poly.
[Kc,tauI,tauD,tauf]=pidplace(a1,a0,b1,b0,Acl);
%case 1
deltat=0.002;
%Tsim=16;
Tsim=6;
Nsim=Tsim/deltat;
r1=0:deltat:(Nsim-1)*deltat;
r2=Nsim*deltat:-deltat:0;
%r=ones(1,Nsim);
r=[r1 r2];

umax=5;
umin=-7; %-30
Dumax=20;
Dumin=-20;
bs=[umax umin Dumax Dumin];
[y,u,Duc,t]=PIDVeImp(Kc,tauI,tauD,tauf,num,den,deltat,r,bs);
Nt=length(t);
r=r(1:length(t));
figure(1)
plot(t,y,'LineWidth',2,'Color',[.6 0 0])
hold on
plot(t,r)
axis([0 12 0 8])
set(gca,'FontSize',20,'FontName','helvetica');
legend('1','2')
ylabel('Output')
xlabel('Time (sec)')

figure(2)
subplot(211) 
plot(t,u,'LineWidth',2,'Color',[.6 0 0])
hold on
plot(t,umax*ones(1,Nt),'-.')
plot(t,umin*ones(1,Nt),'-.')
axis([0 12 -15 15])
set(gca,'FontSize',20,'FontName','helvetica');
ylabel('u')
subplot(212)
plot(t,Duc,'LineWidth',2,'Color',[.6 0 0])
hold on
plot(t,Dumax*ones(1,Nt),'-.')
plot(t,Dumin*ones(1,Nt),'-.')
axis([0 12 -50 50])
set(gca,'FontSize',20,'FontName','helvetica');
ylabel('dot u')


